;;; Support for org-syntax in ASDF

;; BUG: In slime, comma force-compile-system errors with end-of-file if conditions are signalled during compilation
;; It can't find notes

 ;; 10: (SWANK/SBCL::LOCATE-COMPILER-NOTE #P"/home/akater/common-lisp/org-syntax/tests/example.org" (3) "  (DEFUN ORG-SYNTAX.EXAMPLE:DEMO () T)")
 ;;      Locals:
 ;;        FILE = #P"/home/akater/common-lisp/org-syntax/tests/example.org"
 ;;        SOURCE = "  (DEFUN ORG-SYNTAX.EXAMPLE:DEMO () T)"
 ;;        SOURCE-PATH = (3)

(in-package
 ;; todo: maybe do this in a dedicated package org-syntax/asdf
 #:asdf)

(eval-when (:compile-toplevel :load-toplevel :execute)
  (export '(asdf::org-cl-source-file) :asdf))
(defclass org-cl-source-file (cl-source-file)
  ((asdf::type :initform "org")));

;; (defmethod call-with-around-compile-hook :before ((c org-cl-source-file) function)
;;   ;; todo: advice swank here
;;   )

;; (defmethod call-with-around-compile-hook :after ((c org-cl-source-file) function)
;;   ;; todo: unadvice swank here
;;   )

(defmethod call-with-around-compile-hook ((c org-cl-source-file)
                                          (function function))
  (call-around-hook (lambda (f) (declare (type function f))
                      ;; todo: we better prepend a #\Newline
                      ;; to the stream corresponding to c
                      ;; but I don't see dedicated abstractions for streams in ASDF
                      (org-syntax:with-org-syntax
                        (funcall f)))
                    function))

;; TODO: Support the ASDF package-inferred-system extension
;; but not like this, this doesn't work:
;; (defmethod asdf/system:find-system :around (name &optional (error-p t))
;;   "Support for the ASDF package-inferred-system extension"
;;   (declare (ignore name error-p))
;;   (org-syntax:with-org-syntax
;;     (call-next-method)))

(in-package #:org-syntax)

