(cl:defpackage #:org-syntax.util
  (:use #:cl) (:shadow #:if #:variable)
  (:export #:if
           #:o-o
           #:it #:aprog1
           #:string-prefix-p
           #:alist-get #:with-memoization
           #:when-let* #:when-let
           #:wrap-if
           #:pnullf #:incf1
           #:alist #:index
           #:string-prefix-whitespace-p #:string-suffix-whitespace-p
           #:whitespace-char-p
           #:aif #:nullf #:zerof #:aand #:aand1 #:awhen
           #:when1
           #:string-designator
           #:nreversef 
           #:nullf1
           #:position-not #:plist-with-keys
           #:carf #:ensure-string #:until #:nest))

(cl:defpackage #:org-syntax-language
  (:use #:cl #:org-syntax.util)
  (:shadowing-import-from #:org-syntax.util #:if)
  (:export #:ensure #:register-lang-class))

(cl:defpackage #:org-syntax
  (:use #:cl
        #:org-syntax.system #:org-syntax.util #:org-syntax-language)
  (:shadowing-import-from #:org-syntax.util #:if)
  (:shadow #:readtable)
  (:export #:readtable #:with-org-syntax #:with
           #:skip-block-p #:get-readtable #:get-package #:lang
           #:*allow-all-stars-lines*
           ;; these probably better be moved to util:
           #:error-in-stream-at-position
           #:warn-in-stream-at-position

           #:get-stream))

(cl:defpackage #:org-block-language.common-lisp
  (:use #:cl #:org-syntax.util #:org-syntax-language #:org-syntax)
  ;; (:import-from #:org-syntax.system #:*debug* #:when-debug)
  (:shadowing-import-from #:org-syntax.util #:if)
  (:shadowing-import-from #:org-syntax #:readtable))
