;;;; org-syntax.example.asd

;; This used to be a workaround for literate-lisp-related bug
;; https://github.com/jingtaozf/literate-lisp/issues/14
;; I should try to incorporate this somewhere
;; so that compilation notes work with comma force-compile-system

;; #+(and sbcl swank) (in-package #:swank/source-path-parser)
;; #+(and sbcl swank) (when (sb-int:encapsulated-p 'guess-reader-state
;;                                                 :literate-lisp)
;;                      (sb-int:unencapsulate 'guess-reader-state :literate-lisp))
;; #+(and sbcl swank) (sb-int:encapsulate
;;                     'guess-reader-state :literate-lisp
;;                     (lambda (orig-func stream)
;;                       (multiple-value-bind (readtable package) (funcall
;;                                                                 orig-func
;;                                                                 stream)
;;                         (let ((point (file-position stream)))
;;                           (file-position stream 0)
;;                           (let ((line (read-line stream nil nil)))
;;                             (file-position stream point)
;;                             (when (and line (starts-with-p line "# "))
;;                               (setq readtable (copy-readtable readtable))
;;                               (let ((*readtable* readtable))
;;                                 (literate-lisp:install-globally))))
;;                           (values readtable package)))))


(asdf:defsystem #:org-syntax.example
  :author "Dima Akater <nuclearspace@gmail.com>"
  :licence "GPL"
  :version "20240624"
  :serial t
  :description "An example system meant to perform operations on to test ASDF support of org-syntax"
  :defsystem-depends-on (#:org-syntax)
  ;; The :org-cl-source-file below is quite verbose.  However,
  ;; - :org is already in use by literate-lisp
  ;; - In this form, you may write
; :default-component-class asdf::org-cl-source-file
  ;;   to specify how :file is interpreted.
  ;;   See also asdf:*default-component-class*.
  ;; - I have already encountered a case
  ;;   where it seems reasonable to define subclasses,
  ;;   and it thus makes sense to have a verbose identifier.
  ;; - I might make it less verbose
  ;;   but we need enough empirical evidence first.
  :components
  ((:org-cl-source-file "example.package")
   (:org-cl-source-file "example-0-basic")
   (:org-cl-source-file "example-1-with-sharp-property")
   (:org-cl-source-file "example-2-with-eval-when")))
